D. Neutral Tonality-Codeforces Round 908 (Div. 2)

2023-11-10 13:20

本文主要是介绍D. Neutral Tonality-Codeforces Round 908 (Div. 2),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

D. Neutral Tonality

题意:给出两个数组,将第二个数组插入第一个数组,让插入后的数组LIS最小。

复习:LIS-最大上升序列

解决LIS问题使用的方法是dp
dp[i]表示选中第i位,取前i位的最大上升序列的长度
代码如下:

/*不是本题的答案*/
#include<iostream>
using namespace std;
int main()
{int n;cin>>n;int a[n+2];int dp[n+2];for(int i=1;i<=n;i++){cin>>a[i];}for(int i=1;i<=n;i++){//遍历每一位数dp[i]=1;for(int j=1;j<i;j++){//找这个数前面比他小的数,那么这位dp就是上位dp+1(或不变,取最大值)if(a[i]>a[j]){dp[i]=max(dp[i],dp[j]+1);}}}int ans=0;for(int i=1;i<=n;i++){//再次遍历,找到最大的dp输出。ans=max(ans,dp[i]);}cout<<ans<<endl;
}

分析:

那么对于这道题来说,我们并不需要算出LIS的值,题目要求输出合并后的新数组。
那么如何插入能够使得LIS尽量小呢?
降序数组的LIS是最小的,比如5 4 3 2 1这组数的LIS=0;
所以可以将b数组降序插入,首先对b数组降序排序,遍历a数组,对于每一个元素a[i],在这个元素之前插入比a[i]大的所有降序的b数组元素。
代码如下:

#include<iostream>
#include<algorithm>
using namespace std;
bool cmp(int a,int b){return a>b;
}
int main()
{int T;cin>>T;while(T--){int n,m;cin>>n>>m;int a[n+2],b[m+2];for(int i=1;i<=n;i++) cin>>a[i];for(int i=1;i<=m;i++) cin>>b[i];sort(b+1,b+1+m,cmp);// for(int i=1;i<=m;i++) cout<<b[i]<<" ";int pos=1;//数组b的下标for(int i=1;i<=n;i++){while(pos<=m&&b[pos]>a[i]){cout<<b[pos++]<<" ";}cout<<a[i]<<" ";}while(pos<=m){//处理剩余的b数组元素cout<<b[pos++]<<" ";}cout<<endl;}
}

这篇关于D. Neutral Tonality-Codeforces Round 908 (Div. 2)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/382886

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There